'Date: 04/11/06
'Auteur : ShadowTzu
'Site web: http://shadowtzu.free.fr
'eMail: shadowtzu@wanadoo.fr
'Copyright ShadowTzu tout droits rservs

'version directx: Aout 2006
Imports Microsoft.DirectX
Imports Microsoft.DirectX.Direct3D

Public Class Form1
    Private T3D As Engine
    Private Terrain As Terrain
    Private Inp As Input

    Private OnRender As Boolean = True

    Private m_fSpeed As Single = 1 / 0.01
    Private sngAngleX As Single
    Private sngAngleY As Single
    Private sngWalk As Single
    Private sngStrafe As Single
    Private Position As Vector3
    Private LookAt As Vector3

    Private Objet3D As Mesh_static

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.Show()
        Me.Focus()

        T3D = New Engine(Me.Handle, False)

        Terrain = New Terrain(My.Application.Info.DirectoryPath & "\heightmap_low.jpg", 2, 1, 128)
        Terrain.Set_Texture(My.Application.Info.DirectoryPath & "\map_test_TX.jpg", My.Application.Info.DirectoryPath & "\detail.jpg")

        Position = New Vector3(295, 0, 300)

        Objet3D = New Mesh_static(My.Application.Info.DirectoryPath & "\lanternred_mesh.x")

        Objet3D.Position = New Vector3(302, Terrain.Get_Altitude(302, 295) + 1.2, 295)
        Inp = New Input

        Render()
    End Sub

    Private Sub Render()

        Application.DoEvents()
        Dim skycolor As Integer = Get_Color(0.6, 0.8, 1, 1)
        Do While OnRender = True
            Input()
            Set_Camera(Position, LookAt)
            T3D.Render_Clear(skycolor)
            T3D.Render_Begin()

            Terrain.Render()

            Objet3D.Render()

            T3D.Render_End()
            Application.DoEvents()
        Loop
        Objet3D.Dispose()
        Inp.Dispose()
        T3D.Dispose()
        T3D = Nothing
        Application.Exit()
    End Sub

    Private Sub Input()
        If Inp.Key(DirectInput.Key.Escape) Then OnRender = False        
        If Inp.Key(DirectInput.Key.UpArrow) Then sngWalk = 1
        If Inp.Key(DirectInput.Key.DownArrow) Then sngWalk = -1
        If Inp.Key(DirectInput.Key.RightArrow) Then sngStrafe = -1
        If Inp.Key(DirectInput.Key.LeftArrow) Then sngStrafe = 1

        Dim mousex, mousey, mousez As Integer
        Inp.Get_MouseState(mousex, mousey, mousez)
        sngAngleX = sngAngleX - (mousey / 100)
        sngAngleY = sngAngleY - (mousex / 100)

        Dim tempo As Single = T3D.Tempo
        If sngAngleX > 1.3 Then sngAngleX = 1.3
        If sngAngleX < -1.3 Then sngAngleX = -1.3
        Select Case sngWalk
            Case Is > 0
                sngWalk = CSng(sngWalk - 0.01 * tempo)
                If sngWalk < 0 Then sngWalk = 0
            Case Is < 0
                sngWalk = CSng(sngWalk + 0.01 * tempo)
                If sngWalk > 0 Then sngWalk = 0
        End Select

        Select Case sngStrafe
            Case Is > 0
                sngStrafe = CSng(sngStrafe - 0.01 * tempo)
                If sngStrafe < 0 Then sngStrafe = 0
            Case Is < 0
                sngStrafe = CSng(sngStrafe + 0.01 * tempo)
                If sngStrafe > 0 Then sngStrafe = 0
        End Select
        Dim vec As Vector3

        vec.X = CSng(Position.X + (Math.Cos(sngAngleY) * sngWalk / m_fSpeed * tempo) + (Math.Cos(sngAngleY + Math.PI / 2) * sngStrafe / m_fSpeed * tempo))
        vec.Z = CSng(Position.Z + (Math.Sin(sngAngleY) * sngWalk / m_fSpeed * tempo) + (Math.Sin(sngAngleY + Math.PI / 2) * sngStrafe / m_fSpeed * tempo))
        vec.Y = Terrain.Get_Altitude(vec.X, vec.Z) + 1.2
        Position = vec

        Dim reg As Vector3
        reg.X = CSng(Position.X + Math.Cos(sngAngleY))
        reg.Y = CSng(Position.Y + Math.Tan(sngAngleX))
        reg.Z = CSng(Position.Z + Math.Sin(sngAngleY))
        LookAt = reg

    End Sub
   
End Class
