'Date: 04/11/06
'Auteur : ShadowTzu
'Site web: http://shadowtzu.free.fr
'eMail: shadowtzu@wanadoo.fr
'Copyright ShadowTzu tout droits rservs

Imports Microsoft.DirectX
Imports Microsoft.DirectX.Direct3D
Imports Microsoft.DirectX.DirectInput
Public Class Input
    Private MoDev As Microsoft.DirectX.DirectInput.Device
    Private KbDev As Microsoft.DirectX.DirectInput.Device
    Private KbState As Microsoft.DirectX.DirectInput.KeyboardState
    Private MoStateSc As Microsoft.DirectX.DirectInput.MouseState
    Public Disposed As Boolean

    Public Sub New()
        KbDev = New Microsoft.DirectX.DirectInput.Device(Microsoft.DirectX.DirectInput.SystemGuid.Keyboard)
        KbDev.SetDataFormat(Microsoft.DirectX.DirectInput.DeviceDataFormat.Keyboard)
        KbDev.Acquire()
        KbState = KbDev.GetCurrentKeyboardState
        MoDev = New Microsoft.DirectX.DirectInput.Device(Microsoft.DirectX.DirectInput.SystemGuid.Mouse)
        MoDev.SetDataFormat(DeviceDataFormat.Mouse)
        MoDev.Acquire()
        MoStateSc = New DirectInput.MouseState
    End Sub

    Public Function Key(ByVal lTOuche As Microsoft.DirectX.DirectInput.Key) As Boolean
        KbState = KbDev.GetCurrentKeyboardState
        Key = KbState.Item(lTOuche)
    End Function

    Public Sub Get_MouseState(ByRef X As Integer, ByRef Y As Integer, ByRef Z As Integer)
        MoStateSc = MoDev.CurrentMouseState
        Y = MoStateSc.Y
        X = MoStateSc.X
        Z = MoStateSc.Z
    End Sub

    Public Sub Dispose()
        On Error Resume Next
        If Disposed = True Then Exit Sub
        KbDev.Unacquire()
        MoDev.Unacquire()
        MoDev.Dispose()
        KbDev.Dispose()      
        MoDev = Nothing
        KbDev = Nothing
        KbState = Nothing
        MoStateSc = Nothing
        Disposed = True
    End Sub
    Protected Overrides Sub Finalize()
        MyBase.Finalize()
        If Disposed = False Then Dispose()
    End Sub
End Class
